Attribute VB_Name = "IA_AlphaBeta"
'----------------------------------------------------------------------------------------------
'WJChess 0.61 par Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Programme d 'checs pour Win32.
'Ecrit en Visual Basic 6.0
'
'LICENSE
'Ce code source peut tre copi et distribu librement, sans tre modifi.
'Il est fourni sans aucune garanti et support technique.
'Vous pouvez le modifier pour votre usage personnel.
'Vous ne pouvez pas modifier le code source et le distribuer, sous forme compile
'ou non, sans l'accord de l'auteur : Jean-Franois GAZET (jeffgazet@free.fr).
'
'----------------------------------------------------------------------------------------------
'WJChess 0.61 by Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Chess program for Windows 32 bits.
'Written in Visual Basic 6.0
'
'LICENSE
'This source code can be copied and distributed freely, without any modification.
'It comes without any garanty and technical support.
'You can modify it for your own use.
'You can 't modify the source code and distribute it, compiled or not, without the
'author agreement : Jean-Franois GAZET (jeffgazet@free.fr).
'----------------------------------------------------------------------------------------------

Option Explicit

Public Function AlphaBeta(profondeur As Integer, alpha As Integer, beta As Integer, color As Boolean) As Integer

    Dim eval As Integer, IntBest As Integer
    Dim liste_coup As LstCoup
    Dim pos1 As Integer, pos2 As Integer
    Dim i As Integer
    Dim tmppos As echiquier
    
    ' Empche de bloquer le systme pendant la rflexion
    DoEvents
    
    ' Si la mme position se rpte 3 fois => PAT
    'reps = board.CountRepetitions()
    'if reps >= 3 then return 0
    
    ' Test sur la prsence des rois
    If pos_du_pion(-1) = -1 Then
        If color = True Then
            AlphaBeta = -INFINITY + (init_prof - profondeur)
        Else
            AlphaBeta = INFINITY - (init_prof - profondeur)
        End If
        Exit Function
    End If
    If pos_du_pion(1) = -1 Then
        If color = True Then
            AlphaBeta = INFINITY - (init_prof - profondeur)
        Else
            AlphaBeta = -INFINITY + (init_prof - profondeur)
        End If
        Exit Function
    End If
    
    ' Position statique
    If profondeur = 0 Then
        AlphaBeta = evaluer(color)
        Exit Function
    End If

    IntBest = -INFINITY
    
    ' On gnre la liste des coups de l'chiquier
    liste_coup = generer_liste_coup(color)
    
    ' S'il n'y a pas de coups : "Echec et Mat" ou "PAT"
    If array_is_empty(liste_coup.pos1) = True Then
        ' Test si chec et mat
        If echec_et_mat(pos_du_pion(-1)) = True Then
            If color = True Then
                AlphaBeta = -INFINITY + (init_prof - profondeur)
            Else
                AlphaBeta = INFINITY - (init_prof - profondeur)
            End If
            Exit Function
        End If
        If echec_et_mat(pos_du_pion(1)) = True Then
            If color = True Then
                AlphaBeta = INFINITY - (init_prof - profondeur)
            Else
                AlphaBeta = -INFINITY + (init_prof - profondeur)
            End If
            Exit Function
        End If
        AlphaBeta = 0 ' PAT
        Exit Function
    End If

    For i = 0 To UBound(liste_coup.pos1)
        
        pos1 = liste_coup.pos1(i)
        pos2 = liste_coup.pos2(i)
         
        ' On joue le coups
        tmppos = position
        domove pos1, pos2

        eval = -AlphaBeta(profondeur - 1, -beta, -alpha, Not color)
'        Dim k As Byte
'        For k = 1 To profondeur: Print #1, "          ";: Next k
'        Print #1, "p" & profondeur & ":" & pos1 & "-" & pos2 & ":eval=" & eval
        
        ' On dfait le coups
        position = tmppos
               
        If eval > IntBest Then IntBest = eval
        If IntBest >= beta Then Exit For
        If IntBest > alpha Then alpha = IntBest
        
    Next i
    
    AlphaBeta = IntBest
    
End Function

