Attribute VB_Name = "IA_evaluer"
'----------------------------------------------------------------------------------------------
'WJChess 0.61 par Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Programme d 'checs pour Win32.
'Ecrit en Visual Basic 6.0
'
'LICENSE
'Ce code source peut tre copi et distribu librement, sans tre modifi.
'Il est fourni sans aucune garanti et support technique.
'Vous pouvez le modifier pour votre usage personnel.
'Vous ne pouvez pas modifier le code source et le distribuer, sous forme compile
'ou non, sans l'accord de l'auteur : Jean-Franois GAZET (jeffgazet@free.fr).
'
'----------------------------------------------------------------------------------------------
'WJChess 0.61 by Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Chess program for Windows 32 bits.
'Written in Visual Basic 6.0
'
'LICENSE
'This source code can be copied and distributed freely, without any modification.
'It comes without any garanty and technical support.
'You can modify it for your own use.
'You can 't modify the source code and distribute it, compiled or not, without the
'author agreement : Jean-Franois GAZET (jeffgazet@free.fr).
'----------------------------------------------------------------------------------------------

Option Explicit

' Evalue un chiquier
Public Function evaluer(ByVal color As Boolean) As Integer

    Dim i As Byte, j As Byte
    Dim retour As Integer
    
    retour = 0
    
    ' Test sur la prsence des rois
    If pos_du_pion(-1) = -1 Then
        evaluer = -INFINITY
        Exit Function
    End If
    If pos_du_pion(1) = -1 Then
        evaluer = INFINITY
        Exit Function
    End If
    
    '----------------------------------------------------------
    ' Evaluation position Noire (bonus=- malus=+)
    '----------------------------------------------------------
    
    ' Malus si le roi NOIR ne peut plus roquer (empche un dplacement inutile de la tour)
    If position.noir_peut_grand_roque = False Or position.noir_peut_petit_roque = False Then
        retour = retour + 10
    End If
    
    ' Bonus si le roi est bien protg
    ' Grand roque
    If position.pions(2) = -1 Then
        If position.pions(3) = -5 Then
            If position.pions(8) = -6 Then
                If position.pions(9) = -6 Then
                    If position.pions(10) = -6 Then
                        If position.pions(11) = -6 Then
                            retour = retour - 50
                        End If
                    End If
                End If
            End If
        End If
    ' Petit roque
    ElseIf position.pions(6) = -1 Then
        If position.pions(5) = -5 Then
            If position.pions(13) = -6 Then
                If position.pions(14) = -6 Then
                    If position.pions(15) = -6 Then
                        retour = retour - 50
                    End If
                End If
            End If
        End If
    End If
   
    '----------------------------------------------------------
    ' Evaluation position Blanche (bonus=+ malus=-)
    '----------------------------------------------------------
    
    ' Malus si le roi BLANC ne peut plus roquer (empche un dplacement inutile de la tour)
    If position.blanc_peut_grand_roque = False Or position.blanc_peut_petit_roque = False Then
        retour = retour - 10
    End If

    ' Bonus si le roi est bien protg
    ' Grand roque
    If position.pions(58) = 1 Then
        If position.pions(59) = 5 Then
            If position.pions(48) = 6 Then
                If position.pions(49) = 6 Then
                    If position.pions(50) = 6 Then
                        If position.pions(51) = 6 Then
                            retour = retour + 50
                        End If
                    End If
                End If
            End If
        End If
    ' Petit roque
    ElseIf position.pions(62) = 1 Then
        If position.pions(61) = 5 Then
            If position.pions(53) = 6 Then
                If position.pions(54) = 6 Then
                    If position.pions(55) = 6 Then
                        retour = retour + 50
                    End If
                End If
            End If
        End If
    End If

    '----------------------------------------------------------
    '   SCANNE DE L'ECHIQUIER : VALEURS DES PIECES
    '----------------------------------------------------------
    For i = 0 To 63
        '
        ' Pices Noires (bonus=- malus=+)
        '
        If position.pions(i) < 0 Then
           
            ' Valeur du pion
            retour = retour - valeurs_pions(Abs(position.pions(i)))
            
            ' Bonus pour les emplacements des cavaliers,pions,fous (cf. Login p.34)
            If position.pions(i) = -4 Or position.pions(i) = -6 Or position.pions(i) = -3 Then
                retour = retour - bonus_cases(Abs(63 - i))
            End If
            
        '
        ' Pices Blanches (bonus=+ malus=-)
        '
        ElseIf position.pions(i) > 0 Then
               
            ' Valeur du pion
            retour = retour + valeurs_pions(position.pions(i))
            
            ' Bonus pour les emplacements des cavaliers,pions,fous (cf. Login p.34)
            If position.pions(i) = -4 Or position.pions(i) = -6 Or position.pions(i) = -3 Then
                retour = retour + bonus_cases(i)
            End If
        
        End If
    Next i
    
    '-----------------------------------------------------------------------
    ' RECHERCHE DE PIONS DOUBLES
    '-----------------------------------------------------------------------
    Dim nb_pion_blanc As Byte, nb_pion_noir As Byte
    Dim nb_tour_blanc As Byte, nb_tour_noir As Byte
    For i = 0 To 7 ' Pour chaque colonne
        nb_pion_blanc = 0: nb_pion_noir = 0: nb_tour_blanc = 0: nb_tour_noir = 0
        For j = i To (56 + i) Step 8 ' Pour chaque ligne
            If position.pions(j) = 6 Then nb_pion_blanc = nb_pion_blanc + 1 ' Si on a un pion blanc
            If position.pions(j) = -6 Then nb_pion_noir = nb_pion_noir + 1 ' Si on a un pion noir
            If position.pions(j) = 5 Then nb_tour_blanc = nb_tour_blanc + 1 ' Si on a une tour blanche
            If position.pions(j) = -5 Then nb_tour_noir = nb_tour_noir + 1 ' Si on a une tour noire
        Next j

        ' BONUS COLONNE OUVERTE POUR LES TOURS (cad pas de pion b ou n dans la colonne)
        If nb_pion_blanc = 0 And nb_pion_noir = 0 Then
            If nb_tour_blanc > 0 Then
                'MsgBox "Bonus colonne ouverte blancs :" & vbNewLine & "eval=" & retour & "25*" & nb_tour_blanc
                retour = retour + 25 * nb_tour_blanc ' Bonus blanc
            End If
            If nb_tour_noir > 0 Then
                'MsgBox "Bonus colonne ouverte noirs :" & vbNewLine & "eval=" & retour & "-25*" & nb_tour_blanc
                retour = retour - 25 * nb_tour_noir ' Bonus noir
            End If
        End If

        ' PIONS DOUBLES
        If nb_pion_blanc = 2 Then
            'MsgBox "Malus pions doubles blancs :" & vbNewLine & "eval=" & retour & "-20"
            retour = retour - 20 ' Malus aux blancs
        End If
        If nb_pion_noir = 2 Then
            'MsgBox "Malus pions doubles noirs :" & vbNewLine & "eval=" & retour & "+20"
            retour = retour + 20 ' Malus aux noirs
        End If
    Next i
   
    '-----------------------------------------------------------------------
    ' RETOUR DE LA FONCTION SELON LA COULEUR
    '-----------------------------------------------------------------------
    
    If color = True Then
        evaluer = -retour
    Else
        evaluer = retour
    End If

End Function
