Attribute VB_Name = "fonctions"
'----------------------------------------------------------------------------------------------
'WJChess 0.61 par Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Programme d 'checs pour Win32.
'Ecrit en Visual Basic 6.0
'
'LICENSE
'Ce code source peut tre copi et distribu librement, sans tre modifi.
'Il est fourni sans aucune garanti et support technique.
'Vous pouvez le modifier pour votre usage personnel.
'Vous ne pouvez pas modifier le code source et le distribuer, sous forme compile
'ou non, sans l'accord de l'auteur : Jean-Franois GAZET (jeffgazet@free.fr).
'
'----------------------------------------------------------------------------------------------
'WJChess 0.61 by Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Chess program for Windows 32 bits.
'Written in Visual Basic 6.0
'
'LICENSE
'This source code can be copied and distributed freely, without any modification.
'It comes without any garanty and technical support.
'You can modify it for your own use.
'You can 't modify the source code and distribute it, compiled or not, without the
'author agreement : Jean-Franois GAZET (jeffgazet@free.fr).
'----------------------------------------------------------------------------------------------

Option Explicit

' Pour rendre les liens cliquables
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long ' Pour email cliquable

Public Sub VBHref(Commande$)

Dim Foo&, hWnd As Long

Foo = ShellExecute(hWnd, "Open", Commande, "", "", 1)

End Sub

Sub message(strMessage As String)
    MsgBox strMessage, , "WebJeff-Chess"
End Sub

Public Function NomDuPion(id_pion As Integer) As String
    
    Select Case Abs(id_pion)
        Case 1: NomDuPion = "R"
        Case 2: NomDuPion = "D"
        Case 3: NomDuPion = "F"
        Case 4: NomDuPion = "C"
        Case 5: NomDuPion = "T"
        Case 6: NomDuPion = ""
    End Select

End Function

' Retourne "b" ou "n" (sert pour les images  afficher)
' Appel par sub selectionne (ci-dessus)
Public Function couleur_du_pion_en(numcase As Variant) As String

    If position.pions(numcase) < 0 Then
        couleur_du_pion_en = "n"
    Else
        couleur_du_pion_en = "b"
    End If

End Function

Public Function array_is_empty(ByRef tableau As Variant) As Boolean
    
    Dim i As Integer
    
    array_is_empty = False
    
    On Error GoTo err_empty
    i = UBound(tableau)

Exit Function
err_empty:
    array_is_empty = True
    
End Function

' Lance le navigateur
Sub ouvre_navigateur(strUrl As String)
Dim IE As Object

On Error GoTo err_ie
    Set IE = CreateObject("InternetExplorer.Application")
    IE.Width = 808
    IE.Height = 580
    IE.Top = 0
    IE.Left = 0
    IE.Visible = True
    IE.navigate strUrl

Exit Sub
err_ie:
    message ("Impossible d'ouvrir Internet Explorer")
End Sub

' Retourne vrai ou faux si une valeur appartient  un tableau
' (Appel par casex_Click de frm_board pour savoir si le joueur a cliqu sur une case valide)
Public Function in_array(ByRef tableau As Variant, valeur As Variant) As Boolean

Dim element As Variant
    
    in_array = False
    
    ' Si le tableau contient au moins 1 coups  jouer
    If array_is_empty(tableau) = False Then
        For Each element In tableau
            If element = valeur Then
                in_array = True
                Exit For
            End If
        Next element
    End If

End Function

' Pause de temps secondes
Public Sub pause(temps As Integer)
Dim PauseTime, Start, Finish, TotalTime

   PauseTime = temps   ' Dfinit la dure.
   Start = Timer   ' Dfinit l'heure de dbut.
   Do While Timer < Start + PauseTime
      DoEvents   ' Donne le contrle  d'autres processus.
   Loop
   Finish = Timer   ' Dfinit l'heure de fin.
   TotalTime = Finish - Start   ' Calcule la dure totale.

End Sub

' Retourne le numro de case du premier pion attaquant trouv
' Retourne -1 si aucun pion attaquant
Public Function is_attacked(ByVal pos As Integer) As Integer

    Dim i As Integer, element As Variant
    Dim coups_tmp() As Integer
    Dim couleur_pion_attacked As Integer
    
    ' Pour une case vide, on ne sait pas si on recherche
    ' les attaquants noirs ou blancs
    If position.pions(pos) = 0 Then
        If pos > 56 And pos < 63 Then
            couleur_pion_attacked = 1
        Else
            couleur_pion_attacked = -1
        End If
    ' Pour les "pos" qui ont un pions
    Else
        If position.pions(pos) > 0 Then
            couleur_pion_attacked = 1
        Else
            couleur_pion_attacked = -1
        End If
    End If
    
    is_attacked = -1
    
    ' Pour chaque pion du dammier
    For i = 0 To 63
        'si le pion est de couleur oppos  pos
        If position.pions(i) * couleur_pion_attacked < 0 Then
            ' Si c'est le roi (cause bug rcursif)
            If Abs(position.pions(i)) = 1 Then
                ' GAUCHE
                If tab120(tab64(i) - 1) > -1 Then
                    If i - 1 = pos Then
                        is_attacked = i
                        Exit For
                    End If
                End If
                ' DROITE
                If tab120(tab64(i) + 1) > -1 Then
                    If i + 1 = pos Then
                        is_attacked = i
                        Exit For
                    End If
                End If
                ' HAUT
                If tab120(tab64(i) - 10) > -1 Then
                    If i - 8 = pos Then
                        is_attacked = i
                        Exit For
                    End If
                End If
                ' BAS
                If tab120(tab64(i) + 10) > -1 Then
                    If i + 8 = pos Then
                        is_attacked = i
                        Exit For
                    End If
                End If
                ' HAUT-GAUCHE
                If tab120(tab64(i) - 11) > -1 Then
                    If i - 9 = pos Then
                        is_attacked = i
                        Exit For
                    End If
                End If
                ' HAUT-DROITE
                If tab120(tab64(i) - 9) > -1 Then
                    If i - 7 = pos Then
                        is_attacked = i
                        Exit For
                    End If
                End If
                ' BAS-GAUCHE
                If tab120(tab64(i) + 9) > -1 Then
                    If i + 7 = pos Then
                        is_attacked = i
                        Exit For
                    End If
                End If
                ' BAS-DROITE
                If tab120(tab64(i) + 11) > -1 Then
                    If i + 9 = pos Then
                        is_attacked = i
                        Exit For
                    End If
                End If
            Else
                ' Pour tous les autres pions
                coups_tmp = coups(i)
                'si c'est un tableau non vide
                If array_is_empty(coups_tmp) = False Then
                    'pour chaque coup faire
                    For Each element In coups_tmp
                        If element = pos Then
                            is_attacked = i
                            Exit Function
                        End If
                    Next element
                End If
            End If
        End If
    Next i

End Function

' Retourne la pos1 du pion pass en param
' -1 si pas trouv (ne pas retourner 0 : case 0)
Public Function pos_du_pion(id_pion As Integer) As Integer

    Dim i As Integer
    
    pos_du_pion = -1
    
    For i = 0 To 63
        If position.pions(i) = id_pion Then
            pos_du_pion = i
            Exit For
        End If
    Next i

End Function

' Retourne vrai si la pos du roi en argument est echec et mat
Public Function echec_et_mat(pos As Integer) As Boolean

    Dim IntTampon As Integer
    Dim coupstmp() As Integer
    Dim element As Variant
    Dim IntValeur As Integer
    Dim pion_attaquant As Integer
    
    echec_et_mat = False
    
    ' On test s'il y a chec au roi
    pion_attaquant = is_attacked(pos)
    If pion_attaquant > -1 Then

        ' Le roi peut-il bouger sans se faire reprendre ?
        Dim bouge_roi As Boolean
        bouge_roi = False
        If array_is_empty(coups(pos)) = False Then
            bouge_roi = True
        End If
        'MsgBox "bouge_roi=" & bouge_roi

        ' Peut-on prendre le pion qui le met en chec (sauf avec le roi) ?
        Dim prend_pion As Boolean
        prend_pion = False
        pion_attaquant = is_attacked(pion_attaquant)
        If pion_attaquant > -1 And pion_attaquant <> pos Then
            prend_pion = True
        End If
        'MsgBox "prend_pion=" & prend_pion

        ' Peut-il mettre un pion entre (sauf le roi) ?
        ' On scanne chaque coup de mme couleur que le roi
        ' On test si chec
        Dim pion_entre As Boolean
        pion_entre = False
        Dim i As Integer
        For i = 0 To 63
            ' Pour chaque pion de mme couleur que le roi
            ' Sauf le roi
            If i <> pos And position.pions(i) * position.pions(pos) > 0 Then
                coupstmp = coups(i)
                If array_is_empty(coupstmp) = False Then
                    For Each element In coupstmp
                        ' On bouge le pion
                        IntTampon = position.pions(element)
                        position.pions(element) = position.pions(i)
                        position.pions(i) = 0

                        If is_attacked(pos) = -1 Then

                            pion_entre = True

                            ' On remet le pion
                            position.pions(i) = position.pions(element)
                            position.pions(element) = IntTampon

                            i = 64 ' Sort de la boucle "0 to 63"
                            Exit For ' Sort de la boucle "for each element"
                        End If

                        ' on remet le pion
                        position.pions(i) = position.pions(element)
                        position.pions(element) = IntTampon
                    Next element
                End If
            End If
        Next i
        'MsgBox "pion_entre=" & pion_entre

        ' Tout non => chec et mat
        If prend_pion = False And bouge_roi = False And pion_entre = False Then
            echec_et_mat = True
        End If

    End If
    
End Function

Public Sub array_push(ByRef tableau As Variant, element As Variant)

    Dim indicemax As Integer

    ' Evite une erreur pour Ubound(tableau vide)
    On Error Resume Next
    indicemax = UBound(tableau) + 1
        
    ReDim Preserve tableau(indicemax)
    tableau(indicemax) = element

End Sub

' Fin de partie
Public Sub endgame()

' Plus de partie en cours
partie_commencee = False

' On bloque le jeu
bloquer_ordi = True
bloquer_joueur = True

' On arrte les chronos
frm_board.timer_ordi.Enabled = False
frm_board.timer_player.Enabled = False

' On dvrouille les menus
frm_board.deverouiller_les_menus (True)

End Sub

' Retourne le nom du pion, ex : "la tour noire", "le pion blanc"
Public Function NomPion(CasePion As Integer) As String

Select Case position.pions(CasePion)
    Case 1: NomPion = "le roi blanc"
    Case 2: NomPion = "la dame blanche"
    Case 3: NomPion = "le fou blanc"
    Case 4: NomPion = "le cavalier blanc"
    Case 5: NomPion = "la tour blanche"
    Case 6: NomPion = "le pion blanc"
    Case -1: NomPion = "le roi noir"
    Case -2: NomPion = "la dame noire"
    Case -3: NomPion = "le four noir"
    Case -4: NomPion = "le cavalier noir"
    Case -5: NomPion = "la tour noire"
    Case -6: NomPion = "le pion noir"
End Select

End Function

Public Sub printboard()

Dim i As Integer, piece As String
Dim numligne As Integer

numligne = 8

frm_board.txt_board = "   -------------------------------------" & vbNewLine

    For i = 0 To 63
              
        ' numros de lignes
        If (i Mod 8) = 0 Then
            frm_board.txt_board = frm_board.txt_board & numligne & " "
            numligne = numligne - 1
        End If
              
        ' Dfinition du nom de la pice
        Select Case position.pions(i)
            Case -6: piece = "| p "
            Case -5: piece = "| r "
            Case -4: piece = "| n "
            Case -3: piece = "| b "
            Case -2: piece = "| q "
            Case -1: piece = "| k "
            Case 6: piece = "| P "
            Case 5: piece = "| R "
            Case 4: piece = "| N "
            Case 3: piece = "| B "
            Case 2: piece = "| Q "
            Case 1: piece = "| K "
            Case Else: piece = "|    "
        End Select
        
        ' Affichage piece sur son fond
        frm_board.txt_board = frm_board.txt_board & piece

        ' Retour chariot
        If ((i + 1) Mod 8) = 0 Then
            frm_board.txt_board = frm_board.txt_board & "|" & vbNewLine & "   -------------------------------------" & vbNewLine
        End If
    Next i
    
frm_board.txt_board = frm_board.txt_board & "     a    b   c   d   e   f    g   h"

End Sub

Public Function notation_historique(ByVal pos1 As Integer, pos2 As Integer) As String

Dim continuer As Boolean
Dim txt As String

txt = ""
continuer = True

' Si on roque
If Abs(position.pions(pos1)) = 1 Then
    ' Si on roque
    If pos1 = 4 And pos2 = 6 Then
        txt = txt & "o-o": continuer = False
    ElseIf pos1 = 3 And pos2 = 5 Then
        txt = txt & "o-o-o": continuer = False
    ElseIf pos1 = 4 And pos2 = 2 Then
        txt = txt & "o-o-o": continuer = False
    ElseIf pos1 = 3 And pos2 = 1 Then
        txt = txt & "o-o": continuer = False
    ElseIf pos1 = 59 And pos2 = 61 Then
        txt = txt & "o-o-o": continuer = False
    ElseIf pos1 = 60 And pos2 = 62 Then
        txt = txt & "o-o": continuer = False
    ElseIf pos1 = 59 And pos2 = 57 Then
        txt = txt & "o-o": continuer = False
    ElseIf pos1 = 60 And pos2 = 58 Then
        txt = txt & "o-o-o": continuer = False
    End If
End If

' Sinon
If continuer = True Then
    ' Nom du pion
    txt = txt & NomDuPion(position.pions(pos1))
    
    ' Pour pion, cavalier, tour : Si la mme pice de mme couleur
    ' peut aller en pos2, on prcise la colonne
    If Abs(position.pions(pos1)) = 6 Or Abs(position.pions(pos1)) = 4 Or Abs(position.pions(pos1)) = 5 Then
        Dim i As Integer
        Dim couptmp() As Integer, element
        For i = 0 To 63
            ' S'il y a un pion de mme couleur
            If position.pions(i) * position.pions(pos1) > 0 Then
                ' Si c'est la mme pice
                If position.pions(i) = position.pions(pos1) And i <> pos1 Then
                    couptmp = coups(i)
                    If array_is_empty(couptmp) = False Then
                        For Each element In couptmp
                            If element = pos2 Then
                                txt = txt & numcolonne(pos1)
                            End If
                        Next element
                    End If
                End If
            End If
        Next i
    End If
    
    ' X pour prise
    If position.pions(pos2) <> 0 Then txt = txt & "x"
    
    ' Ajout coord. case dest
    txt = txt & num2san(pos2)

End If

notation_historique = txt

End Function

Public Function num2san(numcase As Integer) As String

' Nom des cases
If numcase = 0 Then
    num2san = "a8"
ElseIf numcase = 1 Then
    num2san = "b8"
ElseIf numcase = 2 Then
    num2san = "c8"
ElseIf numcase = 3 Then
    num2san = "d8"
ElseIf numcase = 4 Then
    num2san = "e8"
ElseIf numcase = 5 Then
    num2san = "f8"
ElseIf numcase = 6 Then
    num2san = "g8"
ElseIf numcase = 7 Then
    num2san = "h8"
ElseIf numcase = 8 Then
    num2san = "a7"
ElseIf numcase = 9 Then
    num2san = "b7"
ElseIf numcase = 10 Then
    num2san = "c7"
ElseIf numcase = 11 Then
    num2san = "d7"
ElseIf numcase = 12 Then
    num2san = "e7"
ElseIf numcase = 13 Then
    num2san = "f7"
ElseIf numcase = 14 Then
    num2san = "g7"
ElseIf numcase = 15 Then
    num2san = "h7"
ElseIf numcase = 16 Then
    num2san = "a6"
ElseIf numcase = 17 Then
    num2san = "b6"
ElseIf numcase = 18 Then
    num2san = "c6"
ElseIf numcase = 19 Then
    num2san = "d6"
ElseIf numcase = 20 Then
    num2san = "e6"
ElseIf numcase = 21 Then
    num2san = "f6"
ElseIf numcase = 22 Then
    num2san = "g6"
ElseIf numcase = 23 Then
    num2san = "h6"
ElseIf numcase = 24 Then
    num2san = "a5"
ElseIf numcase = 25 Then
    num2san = "b5"
ElseIf numcase = 26 Then
    num2san = "c5"
ElseIf numcase = 27 Then
    num2san = "d5"
ElseIf numcase = 28 Then
    num2san = "e5"
ElseIf numcase = 29 Then
    num2san = "f5"
ElseIf numcase = 30 Then
    num2san = "g5"
ElseIf numcase = 31 Then
    num2san = "h5"
ElseIf numcase = 32 Then
    num2san = "a4"
ElseIf numcase = 33 Then
    num2san = "b4"
ElseIf numcase = 34 Then
    num2san = "c4"
ElseIf numcase = 35 Then
    num2san = "d4"
ElseIf numcase = 36 Then
    num2san = "e4"
ElseIf numcase = 37 Then
    num2san = "f4"
ElseIf numcase = 38 Then
    num2san = "g4"
ElseIf numcase = 39 Then
    num2san = "h4"
ElseIf numcase = 40 Then
    num2san = "a3"
ElseIf numcase = 41 Then
    num2san = "b3"
ElseIf numcase = 42 Then
    num2san = "c3"
ElseIf numcase = 43 Then
    num2san = "d3"
ElseIf numcase = 44 Then
    num2san = "e3"
ElseIf numcase = 45 Then
    num2san = "f3"
ElseIf numcase = 46 Then
    num2san = "g3"
ElseIf numcase = 47 Then
    num2san = "h3"
ElseIf numcase = 48 Then
    num2san = "a2"
ElseIf numcase = 49 Then
    num2san = "b2"
ElseIf numcase = 50 Then
    num2san = "c2"
ElseIf numcase = 51 Then
    num2san = "d2"
ElseIf numcase = 52 Then
    num2san = "e2"
ElseIf numcase = 53 Then
    num2san = "f2"
ElseIf numcase = 54 Then
    num2san = "g2"
ElseIf numcase = 55 Then
    num2san = "h2"
ElseIf numcase = 56 Then
    num2san = "a1"
ElseIf numcase = 57 Then
    num2san = "b1"
ElseIf numcase = 58 Then
    num2san = "c1"
ElseIf numcase = 59 Then
    num2san = "d1"
ElseIf numcase = 60 Then
    num2san = "e1"
ElseIf numcase = 61 Then
    num2san = "f1"
ElseIf numcase = 62 Then
    num2san = "g1"
ElseIf numcase = 63 Then
    num2san = "h1"
End If

End Function

Public Function san2num(san As String) As Integer

If san = "a8" Then
    san2num = 0
ElseIf san = "b8" Then
    san2num = 1
ElseIf san = "c8" Then
    san2num = 2
ElseIf san = "d8" Then
    san2num = 3
ElseIf san = "e8" Then
    san2num = 4
ElseIf san = "f8" Then
    san2num = 5
ElseIf san = "g8" Then
    san2num = 6
ElseIf san = "h8" Then
    san2num = 7
ElseIf san = "a7" Then
    san2num = 8
ElseIf san = "b7" Then
    san2num = 9
ElseIf san = "c7" Then
    san2num = 10
ElseIf san = "d7" Then
    san2num = 11
ElseIf san = "e7" Then
    san2num = 12
ElseIf san = "f7" Then
    san2num = 13
ElseIf san = "g7" Then
    san2num = 14
ElseIf san = "h7" Then
    san2num = 15
ElseIf san = "a6" Then
    san2num = 16
ElseIf san = "b6" Then
    san2num = 17
ElseIf san = "c6" Then
    san2num = 18
ElseIf san = "d6" Then
    san2num = 19
ElseIf san = "e6" Then
    san2num = 20
ElseIf san = "f6" Then
    san2num = 21
ElseIf san = "g6" Then
    san2num = 22
ElseIf san = "h6" Then
    san2num = 23
ElseIf san = "a5" Then
    san2num = 24
ElseIf san = "b5" Then
    san2num = 25
ElseIf san = "c5" Then
    san2num = 26
ElseIf san = "d5" Then
    san2num = 27
ElseIf san = "e5" Then
    san2num = 28
ElseIf san = "f5" Then
    san2num = 29
ElseIf san = "g5" Then
    san2num = 30
ElseIf san = "h5" Then
    san2num = 31
ElseIf san = "a4" Then
    san2num = 32
ElseIf san = "b4" Then
    san2num = 33
ElseIf san = "c4" Then
    san2num = 34
ElseIf san = "d4" Then
    san2num = 35
ElseIf san = "e4" Then
    san2num = 36
ElseIf san = "f4" Then
    san2num = 37
ElseIf san = "g4" Then
    san2num = 38
ElseIf san = "h4" Then
    san2num = 39
ElseIf san = "a3" Then
    san2num = 40
ElseIf san = "b3" Then
    san2num = 41
ElseIf san = "c3" Then
    san2num = 42
ElseIf san = "d3" Then
    san2num = 43
ElseIf san = "e3" Then
    san2num = 44
ElseIf san = "f3" Then
    san2num = 45
ElseIf san = "g3" Then
    san2num = 46
ElseIf san = "h3" Then
    san2num = 47
ElseIf san = "a2" Then
    san2num = 48
ElseIf san = "b2" Then
    san2num = 49
ElseIf san = "c2" Then
    san2num = 50
ElseIf san = "d2" Then
    san2num = 51
ElseIf san = "e2" Then
    san2num = 52
ElseIf san = "f2" Then
    san2num = 53
ElseIf san = "g2" Then
    san2num = 54
ElseIf san = "h2" Then
    san2num = 55
ElseIf san = "a1" Then
    san2num = 56
ElseIf san = "b1" Then
    san2num = 57
ElseIf san = "c1" Then
    san2num = 58
ElseIf san = "d1" Then
    san2num = 59
ElseIf san = "e1" Then
    san2num = 60
ElseIf san = "f1" Then
    san2num = 61
ElseIf san = "g1" Then
    san2num = 62
ElseIf san = "h1" Then
    san2num = 63
End If

End Function

' Retourne la lettre le la colonne du pion en case "pos"
' (Utilis si 2 pices de mme couleur ont la mme pos2)
Public Function numcolonne(pos As Integer) As String

If pos = 0 Or pos = 8 Or pos = 16 Or pos = 24 Or pos = 32 Or pos = 40 Or pos = 48 Or pos = 56 Then numcolonne = "a"
If pos = 1 Or pos = 9 Or pos = 17 Or pos = 25 Or pos = 33 Or pos = 41 Or pos = 49 Or pos = 57 Then numcolonne = "b"
If pos = 2 Or pos = 10 Or pos = 18 Or pos = 26 Or pos = 34 Or pos = 42 Or pos = 50 Or pos = 58 Then numcolonne = "c"
If pos = 3 Or pos = 11 Or pos = 19 Or pos = 27 Or pos = 35 Or pos = 43 Or pos = 51 Or pos = 59 Then numcolonne = "d"
If pos = 4 Or pos = 12 Or pos = 20 Or pos = 28 Or pos = 36 Or pos = 44 Or pos = 52 Or pos = 60 Then numcolonne = "e"
If pos = 5 Or pos = 13 Or pos = 21 Or pos = 29 Or pos = 37 Or pos = 45 Or pos = 53 Or pos = 61 Then numcolonne = "f"
If pos = 6 Or pos = 14 Or pos = 22 Or pos = 30 Or pos = 38 Or pos = 46 Or pos = 54 Or pos = 62 Then numcolonne = "g"
If pos = 7 Or pos = 15 Or pos = 23 Or pos = 31 Or pos = 39 Or pos = 47 Or pos = 55 Or pos = 63 Then numcolonne = "h"

End Function
